// Geometric Tools, Inc.
// http://www.geometrictools.com
// Copyright (c) 1998-2006.  All Rights Reserved
//
// The Wild Magic Library (WM3) source code is supplied under the terms of
// the license agreement
//     http://www.geometrictools.com/License/WildMagic3License.pdf
// and may not be copied or disclosed except in accordance with the terms
// of that agreement.

#ifndef WM3DELPOLYGONEDGE_H
#define WM3DELPOLYGONEDGE_H

#include "Wm3FoundationLIB.h"
#include "Wm3VEManifoldMesh.h"
#include "Wm3DelTriangle.h"

namespace Wm3
{

template <class Real>
class WM3_ITEM DelPolygonEdge : public VEManifoldMesh::Edge
{
public:
    DelPolygonEdge (int iV0 = -1, int iV1 = -1, int iNullIndex = -1,
            DelTriangle<Real>* pkTri = 0);

    static VEManifoldMesh::EPtr ECreator (int iV0, int iV1);

    int NullIndex;
    DelTriangle<Real>* Tri;
};

typedef DelPolygonEdge<float> DelPolygonEdgef;
typedef DelPolygonEdge<double> DelPolygonEdged;

}

#endif

